
/**
 * The user enters a dollar amount and then we will give the coin change.
 * There are many ways to implement this program. It would depend on how many
 * coins exist in the change machine. For simplicity we are going to assume
 * there are an infinite number of coins. We will preferably hand out large coins
 * rather than small.
 * 
 * Note: The coins I am using are Canadian. Hence the Loonie and Toonie.
 * 
 * @author Shane A 
 */
public class ChangeMachine
{
    public static void main(String[] args) {
        // We use "double" to allow for trailing decimals.
        double value = 0.0; // A "double" variable for holding the users money.
        double tmpValue = 0.0; // Temporary storage for our calculations.
        int toonie = 0;
        int loonie = 0;
        int quarter = 0;
        int dime = 0;
        int nickle = 0;
        int penny = 0;
        
        System.out.print("Enter money value: ");
        value = StdIn.readDouble(); // Read in the user's decimal value into our variable.
        tmpValue = value;
        
        System.out.println();
        
        toonie = (int) (value / 2); // Calculate the number of "toonies" to give.
        
        if (toonie != 0) // If toonies exist, calculate how much money is left.
            tmpValue = (int)value % 2.0; // Use the Moulus (remainder) operator.
        
        loonie = (int) (tmpValue / 1);
        // How much money is left after we give our loonies to the user.
        tmpValue = value - (toonie * 2) - loonie;
        
        // We are now left with a decimal value of how much
        // money hasn't been converted. Eg. 0.77 for 77 cents.
        
        penny = (int)Math.round(tmpValue * 100); // Convert remaining to pennies.
        quarter = (int) (penny / 25);
        
        if (quarter != 0) // If we have given them quarters, re-calculate pennies.
            penny = penny % 25;
        
        dime = (int) (penny / 10);
        if (dime != 0)
            penny = penny % 10;
        
        nickle = (int) (penny / 5);
        if (nickle != 0)
            penny = penny % 5;
        
        System.out.println("Toonies: " + toonie);
        System.out.println("Loonies: " + loonie);
        System.out.println("Quarters: " + quarter);
        System.out.println("Dimes: " + dime);
        System.out.println("Nickels: " + nickle);
        System.out.println("Pennies: " + penny);
    }
}
